import { TestBed } from '@angular/core/testing';
import { ValidationService } from './validation.service';

let validationService: ValidationService;

describe('ValidationService', () => {
  beforeEach(() => {
    TestBed.configureTestingModule({
      providers: [ValidationService]
    });

    validationService = TestBed.inject(ValidationService);
  });

  it('should be created', () => {
    expect(validationService).toBeTruthy();
  });

  it('should return true on a correct username', () => {
    expect(validationService.username('abc')).toEqual({ok: true, error: ''});
  });

  it('should return an error on an incorrect username', () => {
    expect(validationService.username('abc#')).toEqual({ok: false, error: 'username must only contain a-z0-9-_.'});
  });

  it('should return true on a correct password', () => {
    expect(validationService.password('Abc123!#')).toEqual({ok: true, error: ''});
  });

  it('should return an error on an incorrect password', () => {
    expect(validationService.password('Abc123')).toEqual({ok: false, error: 'password must only contain a-zA-Z0-9!"#%&\'()*+,-./:;<=>?@[]^_`{|}~'});
  });

});
